Subject: bug#14644: emacsclient.c fails to compile

From: Stefan Monnier <[email-masked]>
Date: Mon, 17 Jun 2013 12:54:00 -0400

Package: Emacs
Version: 24.3.50

I started getting the following error today:

gcc -std=gnu99     -I. -I../src -I../lib -I/home/monnier/src/emacs/trunk/lib-src -I/home/monnier/src/emacs/trunk/lib-src/../src -I/home/monnier/src/emacs/trunk/lib-src/../lib  -Wl,-znocombreloc   -Wall -g3 -O1 -Wno-pointer-sign /home/monnier/src/emacs/trunk/lib-src/emacsclient.c \
           -DVERSION="\"24.3.50\""  ../lib/libgnu.a   \
             -o emacsclient
In file included from /home/monnier/src/emacs/trunk/lib-src/emacsclient.c:81:0:
../lib/getopt.h:198:8: error: redefinition of ‘struct option’
In file included from ../lib/getopt.h:32:0,
                 from /home/monnier/src/emacs/trunk/lib-src/emacsclient.c:81:
/usr/include/getopt.h:105:8: note: originally defined here
In file included from /home/monnier/src/emacs/trunk/lib-src/emacsclient.c:81:0:
../lib/getopt.h:247:12: error: conflicting types for ‘getopt_long’
In file included from ../lib/getopt.h:32:0,
                 from /home/monnier/src/emacs/trunk/lib-src/emacsclient.c:81:
/usr/include/getopt.h:174:12: note: previous declaration of ‘getopt_long’ was here
In file included from /home/monnier/src/emacs/trunk/lib-src/emacsclient.c:81:0:
../lib/getopt.h:251:12: error: conflicting types for ‘getopt_long_only’
In file included from ../lib/getopt.h:32:0,
                 from /home/monnier/src/emacs/trunk/lib-src/emacsclient.c:81:
/usr/include/getopt.h:178:12: note: previous declaration of ‘getopt_long_only’ was here

This may be due to an "aptitude upgrade" rather than a "bzr update",
since I don't see any recent change that would have caused it.

I don't have time to investigate right now, and the gnulib stuff is
a bit impenetrable to me (e.g. I have no idea where/if
GNULIB_defined_struct_option should be set), so if someone else can
figure it out for me, all the better.

        Stefan

In GNU Emacs 24.3.50.1 (x86_64-unknown-linux-gnu, GTK+ Version 2.24.18)
 of 2013-06-17 on pastel
Bzr revision: [email-masked]
Windowing system distributor `The X.Org Foundation', version 11.0.11204000
System Description:	Debian GNU/Linux testing (jessie)

Configured using:
 `configure -C --enable-checking --enable-check-lisp-object-type
 CFLAGS=-Wall -g3 -O1 -Wno-pointer-sign'

Important settings:
  value of $LANG: fr_CH.UTF-8
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: InactiveMinibuffer

Minor modes in effect:
  diff-auto-refine-mode: t
  electric-pair-mode: t
  electric-indent-mode: t
  url-handler-mode: t
  global-reveal-mode: t
  reveal-mode: t
  auto-insert-mode: t
  savehist-mode: t
  minibuffer-electric-default-mode: t
  mouse-wheel-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
M-o M-n C-x C-s M-x v C-g C-x v = <switch-frame> M-x 
v c - f i n d <tab> <return> M-o C-x C-s <down> <right> 
<right> <right> <right> <right> <right> <right> <right> 
<right> <right> <right> <right> <right> <right> <right> 
<right> <right> <right> <right> <right> <right> <right> 
<right> <right> <right> <right> <right> <right> <right> 
<M-tab> C-a C-x C-s M-x M-p <return> M-m C-x C-s M-x 
M-p <return> M-m C-x C-s M-x M-p <return> C-x C-c C-h 
f k i - b u f f <tab> <return> <help-echo> <down-mouse-2> 
<mouse-1> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <down-mouse-5> 
<mouse-5> <down-mouse-5> <mouse-5> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> <switch-frame> <switch-frame> <switch-frame> 
<switch-frame> M-x r e p - e m - b u <tab> <return

Recent messages:
Error during redisplay: (jit-lock-function 12346678) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12397229) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12396604) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12397104) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12396545) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12397729) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12398229) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12398729) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12399229) signaled (void-variable --regexp--)
Error during redisplay: (jit-lock-function 12399729) signaled (void-variable --regexp--)

Load-path shadows:
/home/monnier/src/emacs/elpa/packages/company/.dir-locals hides /home/monnier/src/emacs/work/lisp/gnus/.dir-locals
/home/monnier/src/emacs/elpa/packages/cl-lib/cl-lib hides /home/monnier/src/emacs/work/lisp/emacs-lisp/cl-lib

Features:
(sort mail-extr emacsbug message format-spec rfc822 mml mml-sec
mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev mailheader
sendmail rfc2047 rfc2045 ietf-drums mail-utils hideif cpp cmacexp
cc-mode two-column kmacro cc-fonts cc-awk cc-guess cc-menus cc-cmds
cc-styles cc-align cc-engine cc-langs cc-vars cc-defs whitespace vc
executable vc-dispatcher copyright xscheme warnings trace testcover
scheme unsafep re-builder profiler shadow cl-indent inf-lisp ielm pp
comint ansi-color ring gmm-utils ert find-func ewoc debug elp edebug
cus-edit cus-start cus-load wid-edit smerge-mode diff-mode vc-bzr
filecache server noutline outline easy-mmode flyspell ispell eldoc
checkdoc thingatpt help-mode load-dir advice help-fns electric
url-handlers url-parse auth-source eieio byte-opt bytecomp byte-compile
cconv eieio-core gnus-util mm-util mail-prsvr password-cache url-vars
reveal autoinsert proof-site proof-autoloads cl pg-vars uniquify
time-date savehist minibuf-eldef disp-table info easymenu package
cl-macs gv cl-lib cl-loaddefs bbdb-autoloads agda2 vm-autoloads tooltip
ediff-hook vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd
fontset image regexp-opt fringe tabulated-list newcomment lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax font-core frame cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese hebrew
greek romanian slovak czech european ethiopic indian cyrillic chinese
case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer nadvice
loaddefs button faces cus-face macroexp files text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote make-network-process dbusbind
gfilenotify dynamic-setting system-font-setting font-render-setting
move-toolbar gtk x-toolkit x multi-tty emacs)